Index: /trunk/src/sys/arch/mips/mips/spl.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/spl.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/spl.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: spl.S,v 1.1.2.6 2010/05/16 00:34:45 matt Exp $	*/
+/*	$NetBSD: spl.S,v 1.1.2.11 2011/04/29 08:26:30 matt Exp $	*/
 
 /*-
@@ -30,4 +30,5 @@
  */
 
+#include "opt_multiprocessor.h"	/* MP kernel? */
 #include "opt_cputype.h"	/* which mips CPU levels do we support? */
 
@@ -38,7 +39,13 @@
 #include <mips/cpuregs.h>
 
-RCSID("$NetBSD: spl.S,v 1.1.2.6 2010/05/16 00:34:45 matt Exp $")
+RCSID("$NetBSD: spl.S,v 1.1.2.11 2011/04/29 08:26:30 matt Exp $")
 
 #include "assym.h"
+
+#if (MIPS1 + MIPS2) > 0
+#define	NOP_L	nop
+#else
+#define	NOP_L	/* nothing */
+#endif
 
 	.data
@@ -56,4 +63,5 @@
 
 	.text
+	.set	noreorder
 /*
  * MIPS processor interrupt control
@@ -67,40 +75,51 @@
 	 * Can only use a0-a3 and v0-v1
 	 */
-	/*
-	 * disable interrupt before messing with spl, or we could be
-	 * preempted and moved to a different CPU
-	 */
+	PTR_L	a3, L_CPU(MIPS_CURLWP)
+	NOP_L					# load delay
+	INT_L	v0, CPU_INFO_CPL(a3)		# get current IPL from cpu_info
+	NOP_L					# load delay
+	sltu	v1, a1, v0			# newipl < curipl
+	bnez	v1, 1f				# yes, don't change.
+	 nop					#  branch delay
 	mfc0	v1, MIPS_COP_0_STATUS		# fetch status register
-	mtc0	zero, MIPS_COP_0_STATUS		## disable interrupts
-	COP0_SYNC
-	PTR_L	a3, L_CPU(MIPS_CURLWP)
-	INT_L	v0, CPU_INFO_CPL(a3)		# get current IPL from cpu_info
-	sltu	a2, a1, v0			# newipl < curipl
-	bnez	a2, 1f				# yes, don't change.
-	nop
+	NOP_L					# load delay
 	or	v1, MIPS_INT_MASK		# enable all interrupts
 	xor	a0, v1				# disable ipl's masked bits
-	DYNAMIC_STATUS_MASK(a0,a2)		# machine dependent masking
+	DYNAMIC_STATUS_MASK(a0,v0)		# machine dependent masking
+	mtc0	zero, MIPS_COP_0_STATUS		## disable interrupts
+	COP0_SYNC
+#ifdef MULTIPROCESSOR
+	PTR_L	a3, L_CPU(MIPS_CURLWP)		## make sure curcpu is correct
+	NOP_L					## load delay
+#endif
 	INT_S	a1, CPU_INFO_CPL(a3)		## save IPL in cpu_info
 	mtc0	a0, MIPS_COP_0_STATUS		## store back
 	COP0_SYNC
-	j	ra
-	 nop
+#ifdef PARANOIA
+	jr	ra
+	 nop					#  branch delay
+#endif /* PARANOIA */
 1:
-	mtc0	v1, MIPS_COP_0_STATUS		# restore status
-	COP0_SYNC
 #ifdef PARANOIA
 	mfc0	v1, MIPS_COP_0_STATUS
-	and	a0, v1				# a0 contains bit that MBZ
+	NOP_L					# load delay
+	and	a0, v1				# a1 contains bit that MBZ
 3:	bnez	a0, 3b				# loop forever
-	 nop
-#endif /* PARANOIA */
-	j	ra
-	 nop
+	 nop					#  branch delay
+#endif /* PARANOIA */
+	jr	ra
+	 nop					#  branch delay
 
 STATIC_LEAF(_splsw_splx)
 STATIC_XLEAF(_splsw_splx_noprof)		# does not get mcount hooks
+#ifdef PARANOIA
+	sltiu	v0, a0, IPL_HIGH+1		# v0 = a0 <= IPL_HIGH
+98:	beqz	v0, 98b
+	 nop
+#endif
 	PTR_L	a3, L_CPU(MIPS_CURLWP)		# get cpu_info
+	NOP_L					# load delay
 	INT_L	a2, CPU_INFO_CPL(a3)		# get IPL from cpu_info
+	NOP_L					# load delay
 	beq	a0, a2, 2f			# if same, nothing to do
 	 sync
@@ -108,8 +127,6 @@
 	sltu	v0, a0, a2			# v0 = a0 < a2
 99:	beqz	v0, 99b				# loop forever if false
-	 nop
-#endif /* PARANOIA */
-	#move	a1, zero			# avoid lookup on splx(IPL_NONE)
-	#beq	a0, zero, 1f			# skip fetch
+	 nop					#  branch delay
+#endif /* PARANOIA */
 	PTR_LA	v1, _C_LABEL(ipl_sr_map)	# get address of table
 	sll	a2, a0, INT_SCALESHIFT		# convert IPL to array offset
@@ -118,4 +135,5 @@
 1:
 	mfc0	v1, MIPS_COP_0_STATUS		# fetch status register
+	NOP_L					# load delay
 	or	v1, MIPS_INT_MASK		# set all INT bits
 	xor	v1, a1				# clear any bits for this IPL
@@ -127,6 +145,6 @@
 	COP0_SYNC
 #ifdef PARANOIA
-	j	ra
-	 nop
+	jr	ra
+	 nop					#  branch delay
 #endif /* PARANOIA */
 2:
@@ -140,20 +158,19 @@
 	xor	a1, MIPS_INT_MASK
 3:	bne	a1, v1, 3b
-	 nop
-#endif /* PARANOIA */
-	j	ra
-	 nop
+	 nop					#  branch delay
+#endif /* PARANOIA */
+	jr	ra
+	 nop					#  branch delay
 END(_splsw_splx)
 
 STATIC_LEAF(_splsw_spl0)
 	INT_L	v1, _C_LABEL(ipl_sr_map) + 4*IPL_NONE
+	PTR_L	a3, L_CPU(MIPS_CURLWP)
 	xor	v1, MIPS_INT_MASK | MIPS_SR_INT_IE # invert and or in IE
-	PTR_L	a3, L_CPU(MIPS_CURLWP)
 	mtc0	zero, MIPS_COP_0_CAUSE		# clear SOFT_INT bits
 	COP0_SYNC
-	mfc0	v0, MIPS_COP_0_STATUS
-	nop
-	nop
-	or	v0, v1
+	mfc0	a0, MIPS_COP_0_STATUS
+	NOP_L					# load delay
+	or	v0, a0, v1
 	DYNAMIC_STATUS_MASK(v0,t0)		# machine dependent masking
 	mtc0	zero, MIPS_COP_0_STATUS		## disable interrupts
@@ -165,7 +182,5 @@
 #endif
 	mtc0	v0, MIPS_COP_0_STATUS		## enable all sources
-	COP0_SYNC
-	j	ra
-	nop
+	JR_HB_RA				# return (clear hazards)
 END(_splsw_spl0)
 
@@ -174,15 +189,11 @@
 	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts (2 cycles)
 	COP0_SYNC
-	nop
-	nop
 	mfc0	v0, MIPS_COP_0_CAUSE		# fetch cause register
-	nop
+	NOP_L					# load delay
 	or	v0, v0, a0			# set soft intr. bits
 	mtc0	v0, MIPS_COP_0_CAUSE		# store back
 	COP0_SYNC
 	mtc0	v1, MIPS_COP_0_STATUS		# enable interrupts
-	COP0_SYNC
-	j	ra
-	nop
+	JR_HB_RA				# return (clear hazards)
 END(_splsw_setsoftintr)
 
@@ -191,6 +202,4 @@
 	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts (2 cycles)
 	COP0_SYNC
-	nop
-	nop
 	mfc0	v0, MIPS_COP_0_CAUSE		# fetch cause register
 	nor	a0, zero, a0			# bitwise inverse of A0
@@ -199,7 +208,5 @@
 	COP0_SYNC
 	mtc0	v1, MIPS_COP_0_STATUS		# enable interrupts
-	COP0_SYNC
-	j	ra
-	nop
+	JR_HB_RA				# return (clear hazards)
 END(_splsw_clrsoftintr)
 
@@ -209,89 +216,106 @@
 	sll	a2, a0, INT_SCALESHIFT
 	PTR_ADDU v1, a2
-	INT_L	a0, (v1)
-	b	_splraise
-	 nop
+	b	_splraise
+	 INT_L	a0, (v1)
 END(_splsw_splraise)
 
 STATIC_LEAF(_splsw_splhigh)
 STATIC_XLEAF(_splsw_splhigh_noprof)
-	/*
-	 * disable interrupt before messing with spl, or we could be
-	 * preempted and moved to a different CPU
-	 */
+	PTR_L	a3, L_CPU(MIPS_CURLWP)
+	NOP_L					# load delay
+	INT_L	v0, CPU_INFO_CPL(a3)		# get current IPL from cpu_info
+	li	a1, IPL_HIGH			# 
+	beq	v0, a1, 1f			# don't do anything if IPL_HIGH
+	 nop					# branch delay
 	mfc0	v1, MIPS_COP_0_STATUS		# fetch status register
+	NOP_L					# load delay
 	and	a0, v1, MIPS_INT_MASK		# select all interrupts
 	xor	a0, v1				# clear all interrupts
-	DYNAMIC_STATUS_MASK(a0,a1)		# machine dependent masking
+	DYNAMIC_STATUS_MASK(a0,a2)		# machine dependent masking
 	mtc0	a0, MIPS_COP_0_STATUS		## store back
 	COP0_SYNC
-	PTR_L	a3, L_CPU(MIPS_CURLWP)
-	INT_L	v0, CPU_INFO_CPL(a3)		# get current IPL from cpu_info
-	li	a1, IPL_HIGH			# 
+#ifdef MULTIPROCESSOR
+	PTR_L	a3, L_CPU(MIPS_CURLWP)		## make sure curcpu is correct
+	NOP_L					## load delay
+#endif
 	INT_S	a1, CPU_INFO_CPL(a3)		## save IPL in cpu_info
-	j	ra				## return
-	 nop
+#ifdef PARANOIA
+	jr	ra				## return
+	 nop					#  branch delay
+#endif /* PARANOIA */
+1:
+#ifdef PARANOIA
+	mfc0	v1, MIPS_COP_0_STATUS		# fetch status register
+	and	v1, MIPS_INT_MASK		# any int bits set?
+2:	bnez	v1, 2b				# loop forever.
+	 nop					# branch delay
+#endif /* PARANOIA */
+	jr	ra				## return
+	 nop					# branch delay
 END(_splsw_splhigh)
 
+	.p2align 4
 STATIC_LEAF(_splsw_splddb)
 	INT_L	a0, _C_LABEL(ipl_sr_map) + 4*IPL_DDB
-	li	a1, IPL_DDB
-	b	_splraise
-	 nop
+	b	_splraise
+	 li	a1, IPL_DDB
+	nop
 END(_splsw_splddb)
 
 STATIC_LEAF(_splsw_splsched)
 	INT_L	a0, _C_LABEL(ipl_sr_map) + 4*IPL_SCHED
-	li	a1, IPL_SCHED
-	b	_splraise
-	 nop
+	b	_splraise
+	 li	a1, IPL_SCHED
+	nop
 END(_splsw_splsched)
 
 STATIC_LEAF(_splsw_splvm)
 	INT_L	a0, _C_LABEL(ipl_sr_map) + 4*IPL_VM
-	li	a1, IPL_VM
-	b	_splraise
+	b	_splraise
+	 li	a1, IPL_VM
+	nop
 END(_splsw_splvm)
 
 STATIC_LEAF(_splsw_splsoftserial)
 	INT_L	a0, _C_LABEL(ipl_sr_map) + 4*IPL_SOFTSERIAL
-	li	a1, IPL_SOFTSERIAL
-	b	_splraise
-	 nop
+	b	_splraise
+	 li	a1, IPL_SOFTSERIAL
+	nop
 END(_splsw_splsoftserial)
 
 STATIC_LEAF(_splsw_splsoftnet)
 	INT_L	a0, _C_LABEL(ipl_sr_map) + 4*IPL_SOFTNET
-	li	a1, IPL_SOFTNET
-	b	_splraise
-	 nop
+	b	_splraise
+	 li	a1, IPL_SOFTNET
+	nop
 END(_splsw_splsoftnet)
 
 STATIC_LEAF(_splsw_splsoftbio)
 	INT_L	a0, _C_LABEL(ipl_sr_map) + 4*IPL_SOFTBIO
-	li	a1, IPL_SOFTBIO
-	b	_splraise
-	 nop
+	b	_splraise
+	 li	a1, IPL_SOFTBIO
+	nop
 END(_splsw_splsoftbio)
 
 STATIC_LEAF(_splsw_splsoftclock)
 	INT_L	a0, _C_LABEL(ipl_sr_map) + 4*IPL_SOFTCLOCK
-	li	a1, IPL_SOFTCLOCK
-	b	_splraise
-	 nop
+	b	_splraise
+	 li	a1, IPL_SOFTCLOCK
+	nop
 END(_splsw_splsoftclock)
 
 STATIC_LEAF(_splsw_splintr)
 	mfc0	ta1, MIPS_COP_0_CAUSE		# get active interrupts
-
+	NOP_L					# load delay
 						# restrict to hard int bits
 	and	v1, ta1, MIPS_HARD_INT_MASK	# now have pending interrupts
 	li	v0, IPL_NONE			#  return IPL_NONE
 	beq	v1, zero, 2f			# quick exit if nothing pending
-	 nop
+	 nop					#  branch delay
 
 	li	v0, IPL_VM			# start at IPL_VM
 	PTR_LA	ta3, _C_LABEL(ipl_sr_map) + 4*IPL_VM
 	INT_L	ta2, -4(ta3)			# load mask for IPL_SOFTSERIAL
+	NOP_L					# load delay
 	xor	ta2, MIPS_INT_MASK		# invert
 	and	v1, ta2				# apply to pending bits
@@ -299,17 +323,18 @@
 1:
 	INT_L	ta2, (ta3)			# get SR bits for ipl in v0
+	NOP_L					# load delay
 	xor	ta2, MIPS_INT_MASK		# invert
 	and	ta2, v1				# any match to pending intrs?
 	beq	ta2, zero, 2f			#  no, return ipl
+	 nop					#  branch delay
 
 	PTR_ADDU ta3, 1 << INT_SCALESHIFT	# point to next entry
 	addiu	v0, 1				#  increase ipl by 1
-	move	v1, ta2				# whittle down pending intrs
 	b	1b				# and check it
+	 move	v1, ta2				# whittle down pending intrs
 
 2:
-	INT_S	v1, (a0)			# return a new pending mask
-	j	ra
-	#nop
+	jr	ra
+	 INT_S	v1, (a0)			# return a new pending mask
 END(_splsw_splintr)
 
@@ -317,4 +342,5 @@
 #ifdef PARANOIA
 	PTR_L	t0, L_CPU(MIPS_CURLWP)
+	NOP_L					# load delay
 	INT_L	t1, CPU_INFO_CPL(t0)		# get current priority level
 
@@ -326,10 +352,11 @@
 	PTR_ADDU t2, t1
 	INT_L	t3, (t2)			# load value
+	NOP_L					# load delay
 	xor	t3, MIPS_INT_MASK		# invert
 1:	bne	t0, t3, 1b			# loop forever if not equal
-	 nop
-#endif /* PARANOIA */
-	j	ra
-	 nop
+	 nop					#  branch delay
+#endif /* PARANOIA */
+	jr	ra
+	 nop					#  branch delay
 END(_splsw_splcheck)
 
Index: /trunk/src/sys/arch/mips/mips/spl_stubs.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/spl_stubs.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/spl_stubs.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: spl_stubs.c,v 1.1.2.2 2010/03/01 19:26:01 matt Exp $ */
+/* $NetBSD: spl_stubs.c,v 1.1.2.3 2010/12/22 06:13:36 matt Exp $ */
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -31,5 +31,5 @@
 #include <sys/cdefs.h>
 
-__KERNEL_RCSID(0, "$NetBSD: spl_stubs.c,v 1.1.2.2 2010/03/01 19:26:01 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: spl_stubs.c,v 1.1.2.3 2010/12/22 06:13:36 matt Exp $");
 
 #define __INTR_PRIVATE
@@ -153,45 +153,2 @@
 	(*mips_splsw.splsw_splcheck)();
 }
-
-void
-fixup_splcalls(void)
-{
-	extern uint32_t _ftext[];
-	extern uint32_t _etext[];
-
-#define	splfixupinfo(x)	{ fixup_addr2offset(x), \
-			  fixup_addr2offset(mips_splsw.splsw_##x) }
-	struct mips_jump_fixup_info fixups[] = {
-		splfixupinfo(splhigh),
-		splfixupinfo(splhigh_noprof),
-		splfixupinfo(splsched),
-		splfixupinfo(splvm),
-		splfixupinfo(splsoftserial),
-		splfixupinfo(splsoftnet),
-		splfixupinfo(splsoftbio),
-		splfixupinfo(splsoftclock),
-		splfixupinfo(spl0),
-		splfixupinfo(splx),
-		splfixupinfo(splx_noprof),
-		splfixupinfo(splraise),
-		splfixupinfo(splintr),
-		splfixupinfo(_setsoftintr),
-		splfixupinfo(_clrsoftintr),
-		splfixupinfo(splcheck),
-	};
-
-	/*
-	 * [bubble] sort fixups from lowest stub to highest stub.
-	 */
-	for (size_t i = 0; i < __arraycount(fixups) - 1; i++) {
-		for (size_t j = i + 1; j < __arraycount(fixups); j++) {
-			if (fixups[i].jfi_stub > fixups[j].jfi_stub) {
-				struct mips_jump_fixup_info tmp = fixups[i];
-				fixups[i] = fixups[j];
-				fixups[j] = tmp;
-			}
-		}
-	}
-
-	mips_fixup_stubs(_ftext, _etext, fixups, __arraycount(fixups));
-}
Index: /trunk/src/sys/arch/mips/mips/svr4_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/svr4_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/svr4_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: svr4_machdep.c,v 1.11 2008/04/28 20:23:28 martin Exp $ */
+/*	$NetBSD: svr4_machdep.c,v 1.11.14.1 2011/04/29 08:26:30 matt Exp $ */
 
 /*-
@@ -37,5 +37,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: svr4_machdep.c,v 1.11 2008/04/28 20:23:28 martin Exp $");
+__KERNEL_RCSID(0, "$NetBSD: svr4_machdep.c,v 1.11.14.1 2011/04/29 08:26:30 matt Exp $");
 
 #include <sys/param.h>
@@ -43,5 +43,4 @@
 #include <sys/proc.h>
 #include <sys/exec.h>
-#include <sys/user.h>
 #include <sys/kernel.h>
 #include <sys/signal.h>
@@ -71,8 +70,5 @@
  */
 int
-svr4_setmcontext(l, mc, flags)
-	struct lwp *l;
-	svr4_mcontext_t *mc;
-	unsigned long flags;
+svr4_setmcontext(struct lwp *l, svr4_mcontext_t *mc, unsigned long flags)
 {
 	printf("Warning: svr4_setmcontext() called\n");
Index: /trunk/src/sys/arch/mips/mips/sys_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/sys_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/sys_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sys_machdep.c,v 1.33.28.1 2010/05/15 20:27:48 matt Exp $	*/
+/*	$NetBSD: sys_machdep.c,v 1.33.28.2 2011/04/29 08:26:30 matt Exp $	*/
 
 /*
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sys_machdep.c,v 1.33.28.1 2010/05/15 20:27:48 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sys_machdep.c,v 1.33.28.2 2011/04/29 08:26:30 matt Exp $");
 
 #include <sys/param.h>
@@ -85,8 +85,4 @@
 			return (error);
 		error = mips_user_cachectl(p, ccua.va, ccua.nbytes, ccua.ctl);
-		break;
-	}
-	case MIPS_TINFOSET: {
-		curlwp->l_md.md_tinfo = (intptr_t)SCARG(uap, parms);
 		break;
 	}
Index: /trunk/src/sys/arch/mips/mips/syscall.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/syscall.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/syscall.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: syscall.c,v 1.37.12.12 2010/02/22 20:17:09 matt Exp $	*/
+/*	$NetBSD: syscall.c,v 1.37.12.15 2011/04/29 08:26:30 matt Exp $	*/
 
 /*-
@@ -31,4 +31,5 @@
 
 /*
+ * Copyright (c) 1988 University of Utah.
  * Copyright (c) 1992, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -66,47 +67,8 @@
  *	@(#)trap.c	8.5 (Berkeley) 1/11/94
  */
-/*
- * Copyright (c) 1988 University of Utah.
- *
- * This code is derived from software contributed to Berkeley by
- * the Systems Programming Group of the University of Utah Computer
- * Science Department and Ralph Campbell.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- * from: Utah Hdr: trap.c 1.32 91/04/06
- *
- *	@(#)trap.c	8.5 (Berkeley) 1/11/94
- */
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: syscall.c,v 1.37.12.12 2010/02/22 20:17:09 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: syscall.c,v 1.37.12.15 2011/04/29 08:26:30 matt Exp $");
 
 #if defined(_KERNEL_OPT)
@@ -118,5 +80,4 @@
 #include <sys/endian.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/signal.h>
 #include <sys/syscall.h>
@@ -145,6 +106,4 @@
 static void EMULNAME(syscall)(struct lwp *, uint32_t, uint32_t, vaddr_t);
 
-register_t MachEmulateBranch(struct trapframe *, register_t, u_int, int);
-
 void
 EMULNAME(syscall_intern)(struct proc *p)
@@ -163,5 +122,5 @@
 
 void
-EMULNAME(syscall)(struct lwp *l, u_int status, u_int cause, vaddr_t opc)
+EMULNAME(syscall)(struct lwp *l, u_int status, u_int cause, vaddr_t pc)
 {
 	struct proc *p = l->l_proc;
@@ -178,5 +137,7 @@
 #if defined(__mips_o32)
 	const int abi = _MIPS_BSD_API_O32;
-	KASSERTMSG(p->p_md.md_abi != abi, ("pid %d(%p): md_abi(%d) != abi(%d)", p->p_pid, p, p->p_md.md_abi, abi));
+	KASSERTMSG(p->p_md.md_abi == abi,
+	    ("pid %d(%p): md_abi(%d) != abi(%d)",
+	    p->p_pid, p, p->p_md.md_abi, abi));
 	size_t nregs = 4;
 #else
@@ -191,7 +152,7 @@
 
 	if (cause & MIPS_CR_BR_DELAY)
-		reg->r_regs[_R_PC] = MachEmulateBranch(tf, opc, 0, 0);
+		reg->r_regs[_R_PC] = mips_emul_branch(tf, pc, 0, false);
 	else
-		reg->r_regs[_R_PC] = opc + sizeof(uint32_t);
+		reg->r_regs[_R_PC] = pc + sizeof(uint32_t);
 
 	callp = p->p_emul->e_sysent;
@@ -401,5 +362,5 @@
 	case ERESTART:
 		reg->r_regs[_R_V0] = saved_v0; /* restore syscall code */
-		reg->r_regs[_R_PC] = opc;
+		reg->r_regs[_R_PC] = pc;
 		break;
 	case EJUSTRETURN:
@@ -424,4 +385,7 @@
 		trace_exit(code, &reg->r_regs[_R_V0], error);
 
+	KASSERT(l->l_blcnt == 0);
+	KASSERT(curcpu()->ci_biglock_count == 0);
+
 	userret(l);
 }
